{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.IOScheme
       (
         IOScheme,
         IOSchemeClass(..),
         ioScheme__0,
         ioScheme__1,
         ioScheme__10,
         ioScheme__11,
         ioScheme__12,
         ioScheme__13,
         ioScheme__14,
         ioScheme__15,
         ioScheme__16,
         ioScheme__17,
         ioScheme__18,
         ioScheme__19,
         ioScheme__2,
         ioScheme__20,
         ioScheme__21,
         ioScheme__22,
         ioScheme__23,
         ioScheme__3,
         ioScheme__4,
         ioScheme__5,
         ioScheme__6,
         ioScheme__7,
         ioScheme__8,
         ioScheme__9,
         ioScheme_compatibleSize,
         ioScheme_describe,
         ioScheme_describeInput,
         ioScheme_describeOutput,
         ioScheme_entry,
         ioScheme_entryEnum,
         ioScheme_entryLabel,
         ioScheme_entryNames,
         ioScheme_index,
         ioScheme_known,
         ioScheme_name,
         ioScheme_size,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Core.Classes.PrintableObject
import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums

instance Show IOScheme where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__0" c_casadi__IOScheme__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__0
  :: String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__0 :: String -> IO IOScheme
ioScheme__0 = casadi__IOScheme__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__1" c_casadi__IOScheme__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__1
  :: String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__1 :: String -> String -> IO IOScheme
ioScheme__1 = casadi__IOScheme__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__2" c_casadi__IOScheme__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__2
  :: String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__2 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__2 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__2 :: String -> String -> String -> IO IOScheme
ioScheme__2 = casadi__IOScheme__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__3" c_casadi__IOScheme__CONSTRUCTOR__3
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__3
  :: String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__3 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__3 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__3 :: String -> String -> String -> String -> IO IOScheme
ioScheme__3 = casadi__IOScheme__CONSTRUCTOR__3


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__4" c_casadi__IOScheme__CONSTRUCTOR__4
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__4
  :: String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__4 x0 x1 x2 x3 x4 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__4 errStrPtrP x0' x1' x2' x3' x4'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__4 :: String -> String -> String -> String -> String -> IO IOScheme
ioScheme__4 = casadi__IOScheme__CONSTRUCTOR__4


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__5" c_casadi__IOScheme__CONSTRUCTOR__5
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__5
  :: String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__5 x0 x1 x2 x3 x4 x5 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__5 errStrPtrP x0' x1' x2' x3' x4' x5'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__5 :: String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__5 = casadi__IOScheme__CONSTRUCTOR__5


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__6" c_casadi__IOScheme__CONSTRUCTOR__6
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__6
  :: String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__6 x0 x1 x2 x3 x4 x5 x6 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__6 errStrPtrP x0' x1' x2' x3' x4' x5' x6'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__6 :: String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__6 = casadi__IOScheme__CONSTRUCTOR__6


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__7" c_casadi__IOScheme__CONSTRUCTOR__7
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__7
  :: String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__7 x0 x1 x2 x3 x4 x5 x6 x7 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__7 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__7 :: String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__7 = casadi__IOScheme__CONSTRUCTOR__7


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__8" c_casadi__IOScheme__CONSTRUCTOR__8
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__8
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__8 x0 x1 x2 x3 x4 x5 x6 x7 x8 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__8 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__8 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__8 = casadi__IOScheme__CONSTRUCTOR__8


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__9" c_casadi__IOScheme__CONSTRUCTOR__9
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__9
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__9 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__9 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__9 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__9 = casadi__IOScheme__CONSTRUCTOR__9


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__10" c_casadi__IOScheme__CONSTRUCTOR__10
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__10
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__10 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__10 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__10 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__10 = casadi__IOScheme__CONSTRUCTOR__10


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__11" c_casadi__IOScheme__CONSTRUCTOR__11
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__11
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__11 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__11 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__11 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__11 = casadi__IOScheme__CONSTRUCTOR__11


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__12" c_casadi__IOScheme__CONSTRUCTOR__12
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__12
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__12 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__12 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__12 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__12 = casadi__IOScheme__CONSTRUCTOR__12


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__13" c_casadi__IOScheme__CONSTRUCTOR__13
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__13
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__13 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__13 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__13 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__13 = casadi__IOScheme__CONSTRUCTOR__13


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__14" c_casadi__IOScheme__CONSTRUCTOR__14
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__14
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__14 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  withMarshal x14 $ \x14' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__14 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13' x14'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__14 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__14 = casadi__IOScheme__CONSTRUCTOR__14


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__15" c_casadi__IOScheme__CONSTRUCTOR__15
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__15
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__15 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  withMarshal x14 $ \x14' ->
  withMarshal x15 $ \x15' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__15 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13' x14' x15'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__15 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__15 = casadi__IOScheme__CONSTRUCTOR__15


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__16" c_casadi__IOScheme__CONSTRUCTOR__16
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__16
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__16 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  withMarshal x14 $ \x14' ->
  withMarshal x15 $ \x15' ->
  withMarshal x16 $ \x16' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__16 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13' x14' x15' x16'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__16 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__16 = casadi__IOScheme__CONSTRUCTOR__16


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__17" c_casadi__IOScheme__CONSTRUCTOR__17
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__17
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__17 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  withMarshal x14 $ \x14' ->
  withMarshal x15 $ \x15' ->
  withMarshal x16 $ \x16' ->
  withMarshal x17 $ \x17' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__17 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13' x14' x15' x16' x17'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__17 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__17 = casadi__IOScheme__CONSTRUCTOR__17


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__18" c_casadi__IOScheme__CONSTRUCTOR__18
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__18
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__18 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  withMarshal x14 $ \x14' ->
  withMarshal x15 $ \x15' ->
  withMarshal x16 $ \x16' ->
  withMarshal x17 $ \x17' ->
  withMarshal x18 $ \x18' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__18 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13' x14' x15' x16' x17' x18'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__18 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__18 = casadi__IOScheme__CONSTRUCTOR__18


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__19" c_casadi__IOScheme__CONSTRUCTOR__19
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> Ptr StdString -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__19
  :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__19 x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 x19 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  withMarshal x4 $ \x4' ->
  withMarshal x5 $ \x5' ->
  withMarshal x6 $ \x6' ->
  withMarshal x7 $ \x7' ->
  withMarshal x8 $ \x8' ->
  withMarshal x9 $ \x9' ->
  withMarshal x10 $ \x10' ->
  withMarshal x11 $ \x11' ->
  withMarshal x12 $ \x12' ->
  withMarshal x13 $ \x13' ->
  withMarshal x14 $ \x14' ->
  withMarshal x15 $ \x15' ->
  withMarshal x16 $ \x16' ->
  withMarshal x17 $ \x17' ->
  withMarshal x18 $ \x18' ->
  withMarshal x19 $ \x19' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__19 errStrPtrP x0' x1' x2' x3' x4' x5' x6' x7' x8' x9' x10' x11' x12' x13' x14' x15' x16' x17' x18' x19'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__19 :: String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> String -> IO IOScheme
ioScheme__19 = casadi__IOScheme__CONSTRUCTOR__19


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__20" c_casadi__IOScheme__CONSTRUCTOR__20
  :: Ptr (Ptr StdString) -> Ptr (StdVec (Ptr StdString)) -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__20
  :: Vector String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__20 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__20 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__20 :: Vector String -> IO IOScheme
ioScheme__20 = casadi__IOScheme__CONSTRUCTOR__20


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__21" c_casadi__IOScheme__CONSTRUCTOR__21
  :: Ptr (Ptr StdString) -> Ptr (StdVec (Ptr StdString)) -> Ptr (StdVec (Ptr StdString)) -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__21
  :: Vector String -> Vector String -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__21 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__21 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__21 :: Vector String -> Vector String -> IO IOScheme
ioScheme__21 = casadi__IOScheme__CONSTRUCTOR__21


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__22" c_casadi__IOScheme__CONSTRUCTOR__22
  :: Ptr (Ptr StdString) -> CInt -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__22
  :: InputOutputScheme -> IO IOScheme
casadi__IOScheme__CONSTRUCTOR__22 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__22 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__22 :: InputOutputScheme -> IO IOScheme
ioScheme__22 = casadi__IOScheme__CONSTRUCTOR__22


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__CONSTRUCTOR__23" c_casadi__IOScheme__CONSTRUCTOR__23
  :: Ptr (Ptr StdString) -> IO (Ptr IOScheme')
casadi__IOScheme__CONSTRUCTOR__23
  :: IO IOScheme
casadi__IOScheme__CONSTRUCTOR__23  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__CONSTRUCTOR__23 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme__23 :: IO IOScheme
ioScheme__23 = casadi__IOScheme__CONSTRUCTOR__23


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__compatibleSize" c_casadi__IOScheme__compatibleSize
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO CInt
casadi__IOScheme__compatibleSize
  :: IOScheme -> Int -> IO Int
casadi__IOScheme__compatibleSize x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__compatibleSize errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_compatibleSize :: IOSchemeClass a => a -> Int -> IO Int
ioScheme_compatibleSize x = casadi__IOScheme__compatibleSize (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__describe" c_casadi__IOScheme__describe
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO (Ptr StdString)
casadi__IOScheme__describe
  :: IOScheme -> Int -> IO String
casadi__IOScheme__describe x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__describe errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_describe :: IOSchemeClass a => a -> Int -> IO String
ioScheme_describe x = casadi__IOScheme__describe (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__describeInput" c_casadi__IOScheme__describeInput
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO (Ptr StdString)
casadi__IOScheme__describeInput
  :: IOScheme -> Int -> IO String
casadi__IOScheme__describeInput x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__describeInput errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_describeInput :: IOSchemeClass a => a -> Int -> IO String
ioScheme_describeInput x = casadi__IOScheme__describeInput (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__describeOutput" c_casadi__IOScheme__describeOutput
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO (Ptr StdString)
casadi__IOScheme__describeOutput
  :: IOScheme -> Int -> IO String
casadi__IOScheme__describeOutput x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__describeOutput errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_describeOutput :: IOSchemeClass a => a -> Int -> IO String
ioScheme_describeOutput x = casadi__IOScheme__describeOutput (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__entry" c_casadi__IOScheme__entry
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO (Ptr StdString)
casadi__IOScheme__entry
  :: IOScheme -> Int -> IO String
casadi__IOScheme__entry x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__entry errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_entry :: IOSchemeClass a => a -> Int -> IO String
ioScheme_entry x = casadi__IOScheme__entry (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__entryEnum" c_casadi__IOScheme__entryEnum
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO (Ptr StdString)
casadi__IOScheme__entryEnum
  :: IOScheme -> Int -> IO String
casadi__IOScheme__entryEnum x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__entryEnum errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_entryEnum :: IOSchemeClass a => a -> Int -> IO String
ioScheme_entryEnum x = casadi__IOScheme__entryEnum (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__entryLabel" c_casadi__IOScheme__entryLabel
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> CInt -> IO (Ptr StdString)
casadi__IOScheme__entryLabel
  :: IOScheme -> Int -> IO String
casadi__IOScheme__entryLabel x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__entryLabel errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_entryLabel :: IOSchemeClass a => a -> Int -> IO String
ioScheme_entryLabel x = casadi__IOScheme__entryLabel (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__entryNames" c_casadi__IOScheme__entryNames
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> IO (Ptr StdString)
casadi__IOScheme__entryNames
  :: IOScheme -> IO String
casadi__IOScheme__entryNames x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__entryNames errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_entryNames :: IOSchemeClass a => a -> IO String
ioScheme_entryNames x = casadi__IOScheme__entryNames (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__index" c_casadi__IOScheme__index
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> Ptr StdString -> IO CInt
casadi__IOScheme__index
  :: IOScheme -> String -> IO Int
casadi__IOScheme__index x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__index errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_index :: IOSchemeClass a => a -> String -> IO Int
ioScheme_index x = casadi__IOScheme__index (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__known" c_casadi__IOScheme__known
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> IO CInt
casadi__IOScheme__known
  :: IOScheme -> IO Bool
casadi__IOScheme__known x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__known errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_known :: IOSchemeClass a => a -> IO Bool
ioScheme_known x = casadi__IOScheme__known (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__name" c_casadi__IOScheme__name
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> IO (Ptr StdString)
casadi__IOScheme__name
  :: IOScheme -> IO String
casadi__IOScheme__name x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__name errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_name :: IOSchemeClass a => a -> IO String
ioScheme_name x = casadi__IOScheme__name (castIOScheme x)


-- direct wrapper
foreign import ccall unsafe "casadi__IOScheme__size" c_casadi__IOScheme__size
  :: Ptr (Ptr StdString) -> Ptr IOScheme' -> IO CInt
casadi__IOScheme__size
  :: IOScheme -> IO Int
casadi__IOScheme__size x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IOScheme__size errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ioScheme_size :: IOSchemeClass a => a -> IO Int
ioScheme_size x = casadi__IOScheme__size (castIOScheme x)

