{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.SymbolicQR
       (
         SymbolicQR,
         SymbolicQRClass(..),
         symbolicQR__0,
         symbolicQR__1,
         symbolicQR__2,
         symbolicQR_creator,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Core.Classes.PrintableObject
import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums

instance Show SymbolicQR where
  show = unsafePerformIO . printableObject_getDescription
-- direct wrapper
foreign import ccall unsafe "casadi__SymbolicQR__CONSTRUCTOR__0" c_casadi__SymbolicQR__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr Sparsity' -> IO (Ptr SymbolicQR')
casadi__SymbolicQR__CONSTRUCTOR__0
  :: Sparsity -> IO SymbolicQR
casadi__SymbolicQR__CONSTRUCTOR__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SymbolicQR__CONSTRUCTOR__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
symbolicQR__0 :: Sparsity -> IO SymbolicQR
symbolicQR__0 = casadi__SymbolicQR__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__SymbolicQR__CONSTRUCTOR__1" c_casadi__SymbolicQR__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr Sparsity' -> CInt -> IO (Ptr SymbolicQR')
casadi__SymbolicQR__CONSTRUCTOR__1
  :: Sparsity -> Int -> IO SymbolicQR
casadi__SymbolicQR__CONSTRUCTOR__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SymbolicQR__CONSTRUCTOR__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
symbolicQR__1 :: Sparsity -> Int -> IO SymbolicQR
symbolicQR__1 = casadi__SymbolicQR__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__SymbolicQR__CONSTRUCTOR__2" c_casadi__SymbolicQR__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr SymbolicQR')
casadi__SymbolicQR__CONSTRUCTOR__2
  :: IO SymbolicQR
casadi__SymbolicQR__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SymbolicQR__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
symbolicQR__2 :: IO SymbolicQR
symbolicQR__2 = casadi__SymbolicQR__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__SymbolicQR__creator" c_casadi__SymbolicQR__creator
  :: Ptr (Ptr StdString) -> Ptr Sparsity' -> CInt -> IO (Ptr LinearSolver')
casadi__SymbolicQR__creator
  :: Sparsity -> Int -> IO LinearSolver
casadi__SymbolicQR__creator x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SymbolicQR__creator errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
symbolicQR_creator :: Sparsity -> Int -> IO LinearSolver
symbolicQR_creator = casadi__SymbolicQR__creator

